#!/usr/bin/python
# -*- coding: utf-8
# --------------------------------------------------------
# Genera un corpus de POSTAGs del corpus DIME etiquetas
# --------------------------------------------------------
# Script: gen_corpus
# --------------------------------------------------------
# Ivan Vladimir Meza-Ruiz
# 2009/IIMAS/UNAM
# --------------------------------------------------------



import os.path
import sys
import re

def usage():
        print '''
Usage:
        ./entrena directorio 

directorio  directorio con etiquetas
'''

if len(sys.argv)!=2:
    usage()
    exit(1)

dir_corpus  =sys.argv[1]

if not os.path.isdir(dir_corpus):
    print "Error con el archivo:", fn_corpus
    usage()
    exit(1)

# Program principal

def get_content(dir,rex):
    files = os.listdir(dir)
    return [ x for x in files if valid_file(x,rex)]

def valid_file(file_name,rex):
    m = rex.match(file_name)
    if m:
        return True
    return False



r_dial = re.compile('d.*')
r_elu = re.compile('utt.*\.txt')
r_phn = re.compile('utt.*\.phn')

dirs = get_content(dir_corpus,r_dial)


def uniform(sntc):
        sntc=sntc.replace(',','')
        sntc=sntc.replace('é','e')
        sntc=sntc.replace('á','a')
        sntc=sntc.replace('í','i')
        sntc=sntc.replace('Ó','o')
        sntc=sntc.replace('Ú','u')
        sntc=sntc.replace('É','e')
        sntc=sntc.replace('Á','a')
        sntc=sntc.replace('í','i')
        sntc=sntc.replace('ó','o')
        sntc=sntc.replace('ú','u')
        sntc=sntc.replace('ü','u')
        sntc=sntc.replace('è','e')
        sntc=sntc.replace('à','a')
        sntc=sntc.replace('ì','i')
        sntc=sntc.replace('ò','o')
        sntc=sntc.replace('ù','u')      
        sntc=sntc.replace('.','')
        sntc=sntc.replace('”','')
        sntc=sntc.replace('“','')
        sntc=sntc.replace('"','')
        sntc=sntc.replace('ñ','n~')
        sntc=sntc.replace('?','')
        sntc=sntc.replace('¿','')
        sntc=sntc.replace('¡','')
        sntc=sntc.replace('!','')
        sntc=sntc.replace('’','')
        sntc=sntc.replace('‘','')
        sntc=sntc.replace(':','')
        sntc=sntc.replace(';','')
        sntc=sntc.replace('-','')
        sntc=sntc.replace('(','')
        sntc=sntc.replace(')','')
        sntc=sntc.replace("'",'')
        return sntc

sup=open('supervisado.whole','w')
unsup=open('corpus_sinsupervision.entrenamiento','w')
voca=open('voca.txt','w')
stat=open('states.txt','w')

voca_=set()
stat_=set()

for dir in dirs:
    poss = get_content(dir_corpus+"/"+dir+"/"+"etiquetas_pos_phn",r_phn)
    elus = get_content(dir_corpus+"/"+dir+"/"+"texto",r_elu)

    elus_={}
    poss_={}
    for elu in elus:
        f1=open(dir_corpus+"/"+dir+"/"+"texto/"+elu,"r")
        elus_[elu]=uniform(f1.readline()).strip().split()
        p=elu.replace('txt','phn')
        if p in poss:
            nl=0
            pp=[]
            for line in open(dir_corpus+"/"+dir+"/"+"etiquetas_pos_phn/"+p,"r"):
                if nl > 2:
                    bits=line.split()
                    pp.append(bits[-1])
                nl+=1
            poss_[elu]=pp[:-1]
    for elu in elus:
        if len(elus_[elu])==0:
            continue
        if not poss_.has_key(elu):
            print >> unsup, " ".join(elus_[elu])
        else:
            ee=[]
            if len(poss_[elu]) > 0 and len(poss_[elu]) == len(elus_[elu]):
                print >> sup, " ".join(elus_[elu]),"@@"," ".join(poss_[elu])
                for p in poss_[elu]:
                    stat_.add(p)
            else:
                print >> unsup, " ".join(elus_[elu])
        for w in elus_[elu]:
            voca_.add(w)

sup.close()
unsup.close()

for w in voca_:
    print >> voca, w

for w in stat_:
    print >> stat, w



